// --  loadbar.java  -----------------------------------------------------

/*
 * =======================================================================
 * =================  PRE-LOADING PROGRESS BAR APPLET  ===================
 * =======================================================================
 *
 * Copyright (C) 1999 Chir 
 * http://www.geocities.com/SiliconValley/Foothills/8436/loadbar.htm
 *
 * DESCRIPTION: this Applet loads files from a text list, and graphically
 *              displays the progress of the loading process.
 *              The files will hopefully be kept in your system's Cache.
 *              Once all files have been loaded, it switches to another page,
 *              typically containing the big Applet you wanted to show in the
 *              first place. That one should then load instantly.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import java.awt.*;
import java.applet.*;
import java.io.*;
import java.net.*;
import java.util.Vector;

public class loadbar extends Applet implements Runnable
{
    Dimension offDimension; // Size of Applet panel.
    Image offImage;         // Double buffering.
    Graphics off_g;         // Double buffering.
    Vector f=new Vector();  // List of files to load.
    int k;                  // Index of file currently loading.
    int l;                  // Amount read from current file (in KB)
    int m;                  // Total amount read so far (in KB)
    int total=9999;         // Total sum of file sizes (in KB)
    Image bg_image=null;    // Optional Image used as background.
    String exit_page;       // Html page to load after finished loading.
    InputStream i_s;        // File currently loading.
    Thread animator_thread , currentThread; // Animation thread.

    private class file
    {
        public String name;
        public int size;
        public file(String n,int s) { name=n; size=s; }
    }

    private InputStream open(String s)
    {
        URL u=null;
        String s2;
        InputStream i_s=null;

        // Try to open a file, by several means, to be compatible with all browsers.
        s2 = "/"+s;
        try { u=Applet.class.getResource(s2); } catch(Exception e0) { }
        if(u==null) try { u=Applet.class.getResource(s); } catch(Exception e0) { }
        if(u==null)
        {
            try { u=new URL(getCodeBase(),s); } catch(MalformedURLException e) { }
            if(u==null)
            {
                try { u=new URL(getCodeBase(),s2); } catch(MalformedURLException e) { }
            }
        }
        if(u==null)
        {
            try { i_s = Applet.class.getResourceAsStream(s2); } catch(Exception e1) { }
            if(i_s==null)
            {
                try { i_s = Applet.class.getResourceAsStream(s); } catch(Exception e2) { }
            }
        }
        else
        {
            try { i_s = u.openStream(); } catch(IOException e) { i_s=null; }
        }
        return(i_s);
    }
    private String read_word(InputStream i_s)
    {
        String s="";
        int c;
        boolean started=false;

        try
        {
            do
            {
                c=i_s.read();
                if(c<=32)
                {
                    if(started) c=-1;   // break
                }
                else
                {
                    s=s+(char)c; started=true;
                }
            } while(c>=0);
        } catch(IOException e) { }
        return s.trim();
    }
    private void draw_bar(Graphics g, int x,int y,int w,int h,float p, Color c)
    {
        if(p>1) p=1;
        off_g.setColor(Color.red); off_g.drawRect(x, y, w, h);
        off_g.setColor(c); off_g.fillRect(x+1, y+1, (int)(p*w)-1, h-1);
    }
    // ---------------------------------------
    public void init()
    {
        int t;
        String q,r;
        InputStream in=null;
        MediaTracker tracker=null;

        // Read parameters from the APPLET tag.
        r = getParameter("BACKGROUNDIMAGE");
        if(r!=null)
        {
            tracker = new MediaTracker(this);
            bg_image = getImage( getCodeBase(), r );
            tracker.addImage(bg_image, 0);
            try { tracker.waitForAll(); } catch(InterruptedException e) { }
        }
        r = getParameter("FILELIST");
        if(r!=null)
        {
            total=1;    // avoid division by zero if no files are specified   :-/
            in = open(r);
            if(in!=null)
            {
                while(true)
                {
                    q=read_word(in); r=read_word(in);
                    if(q.length()==0 || r.length()==0) break;
                    t=9999;
                    try { t = Integer.parseInt(r); } catch (Exception e) { }
                    f.addElement(new file(q,t)); total+=t;
                }
                try { in.close(); } catch(IOException e) { }
            }
        }
        exit_page = getParameter("EXITPAGE"); if(exit_page==null) exit_page="exit.htm";
    }

    public void start()
    {
        // Start animating!
        if(animator_thread == null) { animator_thread = new Thread(this); }
        k=0; m=0;
        animator_thread.start();
    }

    public void stop()
    {
        // Stop the animating thread.
        animator_thread=null; k=0;
        // Get rid of the objects necessary for double buffering.
        off_g = null;
        offImage = null;
    }

    public void run()
    {
        currentThread = Thread.currentThread();
        currentThread.setPriority(Thread.MIN_PRIORITY);
        // This is the animation loop.
        while(currentThread==animator_thread && animator_thread!=null)
        {
            if(i_s==null && k<f.size())
            {
                i_s = open(((file)f.elementAt(k)).name); if(i_s==null) ++k;
                l=0;
            }
            if(i_s==null)
            {
                if(k==f.size())
                {
                    k=0;
                    currentThread=null; // exit thread loop.
                    try
                    {
                        getAppletContext().showDocument(new URL(getCodeBase(),exit_page));
                    }
                    catch(MalformedURLException e2) { }
                }
            }
            else
            {
                try
                {
                    if( i_s.read() >=0 )  { ++l; }  else  { i_s.close(); i_s=null; m+=((file)(f.elementAt(k))).size; ++k; }
                } catch(IOException e) { }
                if((l%1024)==0) repaint();  // Update progress bars every KB
            }
        }
        if(i_s!=null) try { i_s.close(); i_s=null; } catch(IOException e) { }
    }

    public void paint(Graphics g)  { update(g); }

    public void update(Graphics g)
    {
        final int OFFSET=50;    // Distance from border.
        Dimension d = getSize();
        
        if(i_s==null) return;

        // Create the offscreen graphics context, if no good one exists.
        if( (off_g == null) || (d.width != offDimension.width) || (d.height != offDimension.height) )
        {
            offDimension = d;
            offImage = createImage(d.width, d.height);
            off_g = offImage.getGraphics();
        }
        // Erase the previous image.
        if(bg_image==null)
        {
            off_g.setColor(Color.black);
            off_g.fillRect(0, 0, d.width, d.height);
        }
        else
        {
            off_g.drawImage(bg_image,0,0,d.width, d.height,this);
        }
        // Draw progress bars
        draw_bar(off_g,OFFSET,OFFSET,d.width-2*OFFSET,10,((float)l/1024+(float)m)/(float)total,Color.yellow);
        draw_bar(off_g,OFFSET,d.height-OFFSET,d.width-2*OFFSET,10,((float)l/1024)/(float)((file)(f.elementAt(k))).size,Color.green);
        if(k<f.size())
        {
            off_g.setColor(Color.white);
            off_g.drawString(((file)f.elementAt(k)).name,OFFSET,d.height-OFFSET-5);
//            off_g.drawString(" "+m+" KB ["+total+"]",50,70);
        }
        // Paint the image onto the screen.
        g.drawImage(offImage, 0, 0, this);
    }
}
